using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using UnityEngine.EventSystems;


namespace NeMech
{

    public class VRDildo: MVRScript
    {


		const string virsionMmsg = "=== VRDild V1.8 ===\nPC-Paid Content.\nRedistribution prohibited.\nAlteration prohibited\nVRDildo_S012.cs Ver1.8 \n\nCreated by NeMech in 2022/08\nModify by Nemech in 2022/08 \nhttps://www.patreon.com/nemech";
		
		private int counter; 
		private float stopCount;
		private bool direction;
		
		private Vector3 peniT_H;
		private Vector3 peniB_H;
		private Vector3 peniB_I;
		private Vector3 peniB_T;
		private Vector3 peniB_O;
		private Vector3 peniT_O;
		private float speed_aj;
		private Quaternion peniB_B;			// 方向転換向けのバックアップ

		JSONStorableFloat cycleTime;	
		JSONStorableFloat insertOffset;	
		JSONStorableFloat XAngle;
		JSONStorableFloat YAngle;


		JSONStorableFloat distancePerTime;
		JSONStorableFloat sensingThreshold;
		

        public FreeControllerV3 peniBx;
        public FreeControllerV3 peniB;
        private FreeControllerV3 peniT;

        
        private Vector3 VRHand;
        private Vector3 speed;
        private Quaternion VRrotation;
		private float angleV;

		private int pass;
		private char[] di;

        public override void Init()
        {
            try
            {

				SuperController.LogMessage("NeMech VRDildo Loaded");


				// JSONStorableToggle  *** cctiveStatus ***
				activeStatus = new JSONStorableBool("activeStatus", false, activeStatusCallback);
				RegisterBool(activeStatus);
				CreateToggle(activeStatus, activeStatus.val);

				// JSONStorableToggle *** playHand **** 
				playHand = new JSONStorableBool("playHand(check:Left)", false);
				RegisterBool(playHand);
				CreateToggle(playHand, playHand.val);

				// JSONStorableToggle *** playMode **** 
				playMode = new JSONStorableBool("playMode(check:autoMove)", false);
				RegisterBool(playMode);
				CreateToggle(playMode, playMode.val);

				// JSONStorableFloat
				cycleTime = new JSONStorableFloat("cycleTime", 45.0f, DummyFloatCallback, 5.0f, 60.0f, true);
				RegisterFloat(cycleTime);
				dslider = CreateSlider(cycleTime,true);

				// JSONStorableFloat
				insertOffset = new JSONStorableFloat("insertOffset", 0.0f, DummyFloatCallback, -1.0f, 1.0f, true);
				RegisterFloat(insertOffset);
				dslider = CreateSlider(insertOffset,true);

				manualSwTrigger = new JSONStorableAction("resetRotation",resetRotationCallback);
				dbutton = CreateButton("resetRotation",false);
				if (dbutton != null) {
					dbutton.button.onClick.AddListener(resetRotationCallback);
				}

				// NotStorableToggle
				XAngle = new JSONStorableFloat("XAngle", 0.0f, angleChange, -80.0f, 80.0f, true);
				RegisterFloat(XAngle);
				dslider = CreateSlider(XAngle,false);

				// NotStorableToggle
				YAngle = new JSONStorableFloat("YAngle", 0.0f, angleChange, -80.0f, 80.0f, true);
				RegisterFloat(YAngle);
				dslider = CreateSlider(YAngle,false);





				// JSONStorableFloat
				distancePerTime = new JSONStorableFloat("VR distancePerTime", 20.0f, DummyFloatCallback, 1.0f, 100.0f, true);
				RegisterFloat(distancePerTime);
				dslider = CreateSlider(distancePerTime,true);

				// JSONStorableFloat
				sensingThreshold = new JSONStorableFloat("VR sensingThreshold", 4f, DummyFloatCallback, 1f, 15f, true);
				RegisterFloat(sensingThreshold);
				dslider = CreateSlider(sensingThreshold,true);

				// JSONStorableString
				jstring = new JSONStorableString("ContensMessage", virsionMmsg );
				dtext = CreateTextField(jstring);
				dtext.height=360f;


				// JSONStorableString
				moveInfoStr = new JSONStorableString("moveInfo", "" );
				dtext = CreateTextField(moveInfoStr,true);
				dtext.height=30f;


		di = new char[5];


             }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }

			Invoke("initialWaitSub",1.0f);

        }

		private void initialWaitSub(){

				if(activeStatus.val == true){
					activeStatus.toggle.isOn=true;
				} else {
					activeStatus.toggle.isOn=false;
				}

		}

		private JSONStorableString jstring;
		private JSONStorableString moveInfoStr;
		private JSONStorableStringChooser jchooser;
		private UIDynamicSlider dslider;
		private UIDynamicButton dbutton;
		private UIDynamicButton dbuttonStart;
		protected JSONStorableAction manualSwTrigger;

		private JSONStorableBool activeStatus;
		private JSONStorableBool playHand;
		private JSONStorableBool playMode;

		private UIDynamicTextField dtext;

		private void ActionButtonCallback() {

			if( activeStatus.val == true ){
				peniB = containingAtom.GetStorableByID("penisBaseControl") as FreeControllerV3;
				if(peniB == null){

		    		peniB = containingAtom.GetStorableByID("control") as FreeControllerV3;
		    		peniB_O = peniB.transform.localPosition;
					peniT_O = peniB.transform.localPosition;
					peniT_H = peniB.transform.localPosition;
		    		peniB.transform.localPosition = peniB.transform.localPosition - transform.forward * 10f * 0.01f;

				} else {
		    		peniB_O = peniB.transform.localPosition;
					peniT = containingAtom.GetStorableByID("penisTipControl") as FreeControllerV3;
					peniT_O = peniT.transform.localPosition - transform.forward * 1f * 0.01f;
					peniT_H = peniT.transform.localPosition - transform.forward * 1f * 0.01f;
		    		peniB.transform.localPosition = peniB.transform.localPosition - transform.forward * 2f * 0.01f;

				}
				
				peniB_B = peniB.transform.localRotation; //　回転機能オプション
				XAngle.val = 0.0f;
				YAngle.val = 0.0f;


				peniB.currentPositionState = FreeControllerV3.PositionState.On;
				peniB.currentRotationState = FreeControllerV3.RotationState.On;
				peniB_H = peniB.transform.localPosition;

				counter = (int) cycleTime.val;
				direction = true; 
				DummyFloatCallback(distancePerTime) ;

			} else {
				peniB.transform.localPosition = peniB_O;
			}

			moveInfoStr.val = "actionInfo:" + activeStatus.val ;

		}

		private void DummyFloatCallback(JSONStorableFloat jf) {
			peniB_T = peniT_H + (peniT_H - peniB_H ) * (insertOffset.val + 1.01f);
			peniB_I = peniB_H +(peniT_H - peniB_H ) * insertOffset.val;

			Vector3 distVec = peniB_T - peniB_I;
			peniB_T= peniB_I + distVec;
			speed_aj = cycleTime.val/60.0f ;
		}

		// Angle変更時の動作
		private void angleChange(JSONStorableFloat jf){
			peniB.transform.localRotation = peniB_B;
			peniB.transform.Rotate(XAngle.val,YAngle.val,0.0f);
		}

		private void resetRotationCallback(){
			peniB.transform.localRotation = peniB_B;
			XAngle.val = 0.0f;
			YAngle.val = 0.0f;
		}

		private void activeStatusCallback(JSONStorableBool jf){
			ActionButtonCallback();
		}

		void start() {
		}

		void FixedUpdate() {

			Vector3 velocity = Vector3.zero;

			if(activeStatus.val == true) {
				counter = counter - 1;

				if(counter > 0 ) {
					if(playMode.val == true){ 
							if(direction == true ) {
								if(stopCount <= 0.0f){
								peniB.transform.localPosition = Vector3.SmoothDamp(peniB.transform.localPosition,peniB_I,ref velocity,0.07f*speed_aj);

								} else {
									stopCount --;
									counter ++;
								}
							} else {
									peniB.transform.localPosition = Vector3.SmoothDamp(peniB.transform.localPosition,peniB_T,ref velocity,0.04f*speed_aj);
							}
					} else {
						if(pass<=0){
						if(playHand.val){ 
							speed = (VRHand - SuperController.singleton.leftHand.transform.position);
							angleV = Quaternion.Angle(VRrotation,SuperController.singleton.leftHand.transform.rotation);
						} else {
							speed = (VRHand - SuperController.singleton.rightHand.transform.position);
							angleV = Quaternion.Angle(VRrotation,SuperController.singleton.rightHand.transform.rotation);						
						}


						if((( angleV > 0.7) || (speed.magnitude > sensingThreshold.val/1000)) ){

						if(speed.y > 0){
							di[0]=(char)1;
						} else {
							di[0]=(char)0;
						}
							if( (di[0]+di[1]+di[2]) >= 2 ){                                               
								peniB.transform.localPosition = Vector3.SmoothDamp(peniB.transform.localPosition,peniB_T,ref velocity, distancePerTime.val/1000f);
							} else {
								peniB.transform.localPosition = Vector3.SmoothDamp(peniB.transform.localPosition,peniB_I,ref velocity,distancePerTime.val/1000f);
							}
						di[4]=di[3];
						di[3]=di[2];
						di[2]=di[1];
						di[1]=di[0];
						}
						if(playHand.val){
							VRHand = SuperController.singleton.leftHand.transform.position;
							VRrotation = SuperController.singleton.leftHand.transform.rotation;

						} else {
							VRHand = SuperController.singleton.rightHand.transform.position;
							VRrotation = SuperController.singleton.rightHand.transform.rotation;
						}
							pass = 3;
						}
						pass = pass -1;
					}
				} else {
					counter= (int) cycleTime.val;
					direction = !direction;
					if( cycleTime.val > 55 )
						stopCount = (cycleTime.val-50)* 50.0f;
					else
						stopCount = cycleTime.val/3.0f -1;
				}
			}
		}
    }

}